public class CheckJavaVersion
{
    static public void main(String[] args)
    {
	String java_version = System.getProperty("java.version");
	System.out.println("Java version: " + java_version);

	try {
	    // Identify major version number
	    int major_dot_position = java_version.indexOf(".");
	    String java_version_major_string = java_version.substring(0, major_dot_position);
	    int java_version_major = (new Integer(java_version_major_string)).intValue();

	    // Identify minor version number
	    int minor_dot_position = java_version.indexOf(".", major_dot_position + 1);
	    String java_version_minor_string = java_version.substring(major_dot_position + 1, minor_dot_position);
	    int java_version_minor = (new Integer(java_version_minor_string)).intValue();

	    // Version of Java must be 1.4 or higher to run the GLI
	    if (java_version_major > 1 || (java_version_major == 1 && java_version_minor >= 4)) {
		// Valid
		System.exit(2);
	    }
	    else {
		// Invalid
		System.exit(1);
	    }
	}
	catch (Exception exception) {
	    System.err.println("Exception: " + exception);
	}
    }
}
